--[[ 
Options 7.3.0.00

Options menu for "Let's Ride"
--]]

local addonName, addonTable = ...

-- It is for fun
local function OptionsUpdate(option)

	if (option == "btn2") then
		local i = random(3)
		local msg = "placeholder"..i
		addonTable.MessageOut(addonTable[tostring(msg)]);
	end

end

function addonTable.BlizzardOptions()

  -- Create main frame for information text
  local LetsRideOptionsFrame = CreateFrame("FRAME", "LetsRideOptionsFrame")
	LetsRideOptionsFrame.name = GetAddOnMetadata("LetsRide", "Title");
--	LetsRideOptionsFrame.default = function(self) addonTable.ResetConfig(); end
	LetsRideOptionsFrame.refresh = function(self) addonTable.SetCheckButtonState(); end
	InterfaceOptions_AddCategory(LetsRideOptionsFrame);

  -- Header Title
  local OptionsHeader = LetsRideOptionsFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	OptionsHeader:SetJustifyH("LEFT");
	OptionsHeader:SetJustifyV("TOP");
	OptionsHeader:ClearAllPoints();
	OptionsHeader:SetPoint("TOPLEFT", 16, -16);
--	OptionsHeader:SetText("Let's Ride! "..addonTable.Version);
	OptionsHeader:SetText("Let's Ride!");
	
  -- Author 
  local OptionsAuthor = LetsRideOptionsFrame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
	OptionsAuthor:SetJustifyH("LEFT");
	OptionsAuthor:SetJustifyV("TOP");
	OptionsAuthor:ClearAllPoints();
	OptionsAuthor:SetPoint("TOPRIGHT", LetsRideOptionsFrame, "TOPRIGHT", -16, -16);
	OptionsAuthor:SetText("Author: " .. addonTable.Author);

  -- Subtitle: section 1 "General"
  local OptionsSub1 = LetsRideOptionsFrame:CreateFontString(nil, "ARTWORK")
	OptionsSub1:SetFontObject(GameFontWhite);
	OptionsSub1:SetJustifyH("LEFT");
	OptionsSub1:SetJustifyV("TOP");
	OptionsSub1:ClearAllPoints();
	OptionsSub1:SetPoint("TOPLEFT", OptionsHeader, "BOTTOMLEFT", 0, -16);
	OptionsSub1:SetText(addonTable.sub1);

  -- Checkbox 1: 
  local CheckButton1 = CreateFrame("CheckButton", "CheckButton1", LetsRideOptionsFrame, "OptionsCheckButtonTemplate")
	CheckButton1:SetPoint("TOPLEFT", OptionsSub1, "BOTTOMLEFT", 16, -4);
--	CheckButton1:SetScript("OnClick", function(self) OptionsUpdate("btn1"); end)
	CheckButton1Text:SetText(addonTable.sub1B1);

  -- Checkbox 2:
  local CheckButton2 = CreateFrame("CheckButton", "CheckButton2", LetsRideOptionsFrame, "OptionsCheckButtonTemplate")
	CheckButton2:SetPoint("TOPLEFT", CheckButton1, "BOTTOMLEFT", 0, -4);
	CheckButton2:SetScript("OnClick", function(self) OptionsUpdate("btn2"); end)
	CheckButton2Text:SetText(addonTable.sub1B2);

  -- Subtitle: section 2 "Favorites"
  local OptionsFavorites = LetsRideOptionsFrame:CreateFontString(nil, "ARTWORK")
	OptionsFavorites:SetFontObject(GameFontWhite)
	OptionsFavorites:SetJustifyH("LEFT") 
	OptionsFavorites:SetJustifyV("TOP")
	OptionsFavorites:ClearAllPoints()
	OptionsFavorites:SetPoint("TOPLEFT", CheckButton2, "BOTTOMLEFT", -16, -12)
	OptionsFavorites:SetText(addonTable.sub2)

  -- Sliderbar1: Adjust frequency of "favorites" being summoned
  local Sliderbar1 = CreateFrame("Slider", "Sliderbar1", LetsRideOptionsFrame, "OptionsSliderTemplate")
	LetsRideOptionsFrame.ScalingSlider = slider;
	Sliderbar1:SetOrientation("HORIZONTAL");
	Sliderbar1:SetMinMaxValues(1, 11);
	Sliderbar1:SetValueStep(1);
	Sliderbar1:SetObeyStepOnDrag(true);
	Sliderbar1:SetWidth(180);
	Sliderbar1:SetHeight(16);
	Sliderbar1:SetPoint("TOPLEFT", OptionsFavorites, "BOTTOMLEFT", 20, -20);
	_G[Sliderbar1:GetName().."High"]:SetText(addonTable.slideHigh);
	_G[Sliderbar1:GetName().."Low"]:SetText(addonTable.slideLow);
	_G[Sliderbar1:GetName().."Text"]:SetText(addonTable.slideText);

--[[	
  -- OnShow Event
  LetsRideOptionsFrame:SetScript("OnShow", function(frame)
	CheckButton1:SetChecked(LetsRideOptions.checkbox1);
	CheckButton2:SetChecked(LetsRideOptions.checkbox2);
	Sliderbar1:SetValue(LetsRideOptions.favoritePriority);
  end)
--]]

  -- Okay Action 
  function LetsRideOptionsFrame.okay(...)
	if (LetsRideOptions.checkbox1 ~= CheckButton1:GetChecked()) then
	  LetsRideOptions.checkbox1 = CheckButton1:GetChecked();
	  addonTable.sortMounts, addonTable.favMounts = addonTable.SortMounts();
	end
	
	LetsRideOptions.checkbox2 = CheckButton2:GetChecked();
	LetsRideOptions.favoritePriority = Sliderbar1:GetValue();
  end
	
end

-- ResetConfig sets the default Interface Options
function addonTable.ResetConfig()
  print("Resetting")
  LetsRideOptions = {
	version = addonTable.Version,
	checkbox1 = true,
	checkbox2 = true,
	favoritePriority = 8
  }
  
end

-- SetCheckButtonState displays the current user defined options
function addonTable.SetCheckButtonState()
  CheckButton1:SetChecked(LetsRideOptions.checkbox1);
  CheckButton2:SetChecked(LetsRideOptions.checkbox2);
  Sliderbar1:SetValue(LetsRideOptions.favoritePriority);

end